##
##  Copyright 2004 Stefano Di Paola <stefano.dipaola[at]wisec.it>
##
##  Released under GPL 2.0
##
##
package RegExtract;

use Regexp::Assemble;
use Data::Dumper;



sub get_matching_regex {
my ($prevre,$str)=@_;
my %chars=();
my @reg;
my $numbers=0;
my $alpha=0;
my $spaces=0;
my $ra;
if(!defined($prevre)){
 $ra = Regexp::Assemble->new(reduce=>1);
}else{
 $ra= $prevre;
}

while($str ne ''){
#print $str." ---------------- \n";
if($str =~ s/\d//)
{
$numbers++;
}elsif($str =~ s/[[:alpha:]]//)
{
 $alpha++;
}
# elsif($str =~ s/[[:punct:]]//)
# {$spaces++;
# }
else{
my $char= substr($str, 0,1) ;
if(!exists($chars{$char})){
 $chars{$char}=1;
 }else{
  $chars{$char}+=1};
$str =~ s/$char//;
#print $chars{$char}." exic:".exists($chars{$char})." fffffff\n";
}
}

if($alpha==1){
 $ra->add( '[:alpha:]' );
}elsif($alpha>1){
 $ra->add( '[:alpha:]*' );
}

if($numbers==1){
 $ra->add( "\\d" );
}elsif($numbers>1){
 $ra->add( "\\d*");
}
#print Dumper(%chars);
while (my ($key,$val) = each %chars)
 { 
	if($val==1){
	$ra->add( "$key" );
       }elsif($val >1){
       $ra->add(  "\\$key*" );
       } 
 }
 
return $ra;

}
1;
